"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var clicore_1 = require("clicore");
var path = require("path");
var filesMap = [
    ['index.ts.txt', 'src/blueprints/__name__/index.ts'],
    ['README.md.txt', 'src/blueprints/__name__/templates/README.md'],
];
var NewProjectBlueprint = (function (_super) {
    __extends(NewProjectBlueprint, _super);
    function NewProjectBlueprint() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.name = 'blueprint';
        _this.description = 'Create new blueprint';
        _this.options = [
            { name: 'name', type: 'string', description: 'Blueprint name', require: true, ask: true },
            { name: 'description', type: 'string', description: 'Blueprint description', require: true, ask: true },
        ];
        return _this;
    }
    NewProjectBlueprint.prototype.prepare = function (options) {
        this.templateParams = {
            __name__: options['name'],
            __description__: options['description'],
        };
    };
    NewProjectBlueprint.prototype.generateChanges = function () {
        return this.createFilesFromTemplates(path.join(__dirname, 'templates'), filesMap, this.templateParams).slice();
    };
    return NewProjectBlueprint;
}(clicore_1.Blueprint));
exports.default = NewProjectBlueprint;
