"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var clicore_1 = require("clicore");
var path = require("path");
var Chalk = require("chalk");
var filesMap = [
    ['cli.ts.txt', '__name__/src/cli.ts'],
    ['gitignore.txt', '__name__/.gitignore.ts'],
    ['package.json.txt', '__name__/package.json'],
    ['tsconfig.json.txt', '__name__/tsconfig.json']
];
var NewProjectBlueprint = (function (_super) {
    __extends(NewProjectBlueprint, _super);
    function NewProjectBlueprint() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.name = 'new';
        _this.description = 'Create new cli project';
        _this.options = [
            { name: 'name', type: 'string', description: 'Cli tool name', require: true, ask: true },
            { name: 'description', type: 'string', description: 'Cli tool description', require: false, ask: true },
            { name: 'bin-name', type: 'string', description: 'Cli tool command line name', require: false, ask: false },
            { name: 'author', type: 'string', description: 'Author', require: true, ask: true },
            {
                name: 'config-file-name',
                type: 'string',
                description: 'Name of the config file for cli',
                require: false,
                ask: false
            }
        ];
        return _this;
    }
    NewProjectBlueprint.prototype.prepare = function (options) {
        options['bin-name'] = options['bin-name'] !== undefined ? options['bin-name'] : options['name'];
        options['config-file-name'] = options['config-file-name'] !== undefined ? options['config-file-name'] : "." + options['name'] + ".json";
        this.templateParams = {
            __name__: options['name'],
            __description__: options['description'],
            __bin_name__: options['bin-name'],
            __author__: options['author'],
            __config_file_name__: options['config-file-name'],
        };
    };
    NewProjectBlueprint.prototype.generateChanges = function () {
        return this.createFilesFromTemplates(path.join(__dirname, 'templates'), filesMap, this.templateParams).slice();
    };
    NewProjectBlueprint.prototype.postApply = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        console.log(Chalk.green('Installing node packages for you... this may take a while'));
                        return [4 /*yield*/, this.executeCommand(this.templateParams.__name__, 'yarn || npm i')];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    return NewProjectBlueprint;
}(clicore_1.Blueprint));
exports.default = NewProjectBlueprint;
